/****************************************************************************

DESCRIPTION: Core/driver/shim shared definitions

THIS PROGRAM AND THE INFORMATION CONTAINED HEREIN IS THE PROPERTY OF
ATTO TECHNOLOGY, INC. AND SHALL NOT BE REPRODUCED, COPIED, OR USED IN
WHOLE OR IN PART OTHER THAN AS PROVIDED FOR IN THE LICENSE AGREEMENT
PURSUANT TO WHICH IT WAS FURNISHED.

COPYRIGHT (c) ATTO TECHNOLOGY, INC. 2003-2017
ALL RIGHTS RESERVED.
UNPUBLISHED CONFIDENTIAL INFORMATION OF ATTO TECHNOLOGY, INC.

*****************************************************************************/

#ifndef ATTO_H


#ifndef ATTO_CFG_H

/* Version info */

#include <vertypes.h>
#include <buildver.h>

#define AV_FULL_VERSION_STR AV_VERSION_STR VT_BLD_CFG_STR VT_BLD_MP_STR

#endif

/* Logging */

#define ATTO_LOG_NONE   0x00000000 /* none                          */
#define ATTO_LOG_INIT   0x00000001 /* Initialization messages       */
#define ATTO_LOG_TASKM  0x00000002 /* Task management messages      */
#define ATTO_LOG_D2GPU  0x00000004 /* Direct2GPU messages           */
#define ATTO_LOG_XPORT  0x00000008 /* SCSI Transport (fc,sas)       */
#define ATTO_LOG_CORE   0x00000010 /* ATTO core messages            */
#define ATTO_LOG_SCSI   0x00000020 /* SCSI mid-layer interfacing    */
#define ATTO_LOG_PCI    0x00000040 /* PCI driver interface          */
#define ATTO_LOG_DISC   0x00000100 /* Discovery messages            */
#define ATTO_LOG_IOCTL  0x00000200 /* IOCTL messages                */
#define ATTO_LOG_NVME   0x00000800 /* NVMe messages                 */
#define ATTO_LOG_MP     0x00001000 /* Multipathing messages         */
#define ATTO_LOG_EVENT  0x00040000 /* attocfg async event           */
#define ATTO_LOG_DEBUG  0x40000000 /* Debug messages                */
#define ATTO_LOG_ALL    0xffffffff /* All events                    */

#if defined(HW_DEBUG)
#define ATTO_LOG_MASK_DEFAULT   ATTO_LOG_ALL
#elif defined(HW_TRACING)
#define ATTO_LOG_MASK_DEFAULT   (ATTO_LOG_ALL & ~ATTO_LOG_DEBUG)
#else
#define ATTO_LOG_MASK_DEFAULT   (ATTO_LOG_ALL & ~(ATTO_LOG_DEBUG | ATTO_LOG_IOCTL))
#endif


#endif /* ATTO_H */
