/****************************************************************************

DESCRIPTION: HWADAPTER-less OS layer definitions used by HW layers - an
extension of oshwshared.h for shared core/driver layer functions.

THIS PROGRAM AND THE INFORMATION CONTAINED HEREIN IS THE PROPERTY OF
ATTO TECHNOLOGY, INC. AND SHALL NOT BE REPRODUCED, COPIED, OR USED IN
WHOLE OR IN PART OTHER THAN AS PROVIDED FOR IN THE LICENSE AGREEMENT
PURSUANT TO WHICH IT WAS FURNISHED.

COPYRIGHT (c) ATTO TECHNOLOGY, INC. 2003-2017
ALL RIGHTS RESERVED.
UNPUBLISHED CONFIDENTIAL INFORMATION OF ATTO TECHNOLOGY, INC.

*****************************************************************************/


#ifndef OSHWCMN_H
#define OSHWCMN_H


#ifdef __KERNEL__
#if LINUX_VERSION_CODE < KERNEL_VERSION(5,16,0) && !IS_RHEL_RELEASE_OR_LATER(9,1)
#include <stdarg.h>
#else
#include <linux/stdarg.h>
#endif
#else
#define va_start(v,l)   __builtin_va_start(v,l)
#define va_end(v)       __builtin_va_end(v)
#define va_arg(v,l)     __builtin_va_arg(v,l)
#endif  /* __KERNEL__ */

#define atdf_set_bits(field, bits)      __sync_fetch_and_or(field, bits)
#define atdf_clear_bits(field, bits)    __sync_fetch_and_and(field, ~(bits))

#define atdf_decrement(count)           __sync_fetch_and_sub(count, 1)
#define atdf_increment(count)           __sync_fetch_and_add(count, 1)

void        atdf_spinlock_acquire( spinlock_t* lock, unsigned long* flags );
void        atdf_spinlock_release( spinlock_t* lock, unsigned long* flags );
spinlock_t* atdf_spinlock_init( void );
void        atdf_spinlock_free( spinlock_t* lock );


#endif /* OSHWCMN_H */
