/****************************************************************************

DESCRIPTION: Platform-dependent data types & such

THIS PROGRAM AND THE INFORMATION CONTAINED HEREIN IS THE PROPERTY OF
ATTO TECHNOLOGY, INC. AND SHALL NOT BE REPRODUCED, COPIED, OR USED IN
WHOLE OR IN PART OTHER THAN AS PROVIDED FOR IN THE LICENSE AGREEMENT
PURSUANT TO WHICH IT WAS FURNISHED.

COPYRIGHT (c) ATTO TECHNOLOGY, INC. 2003-2017
ALL RIGHTS RESERVED.
UNPUBLISHED CONFIDENTIAL INFORMATION OF ATTO TECHNOLOGY, INC.

*****************************************************************************/


#ifndef _OSTYPES_H_
#define _OSTYPES_H_


#define OS_LOCK_STATE   unsigned long

typedef unsigned char       u8;
typedef unsigned short      u16;
typedef unsigned int        u32;
typedef unsigned long long  u64;
typedef __builtin_va_list   va_list;


#ifdef __KERNEL__
#include <linux/spinlock.h>
#define OS_SPIN_LOCK    spinlock_t*
#endif

#ifdef KERNEL_CORE
typedef struct spinlock spinlock_t;
#define OS_SPIN_LOCK    spinlock_t*
#endif


/* The drivers have been defining these in the makefile to date; the ConfigTool
 * daemon has been using this definition.  Allow for both modes.  The macros
 * can be listed by running:
 *
 *    $ gcc -dM -E - <<<''
 *
 * A list of symbols is here:
 *
 *   http://sourceforge.net/p/predef/wiki/Architectures/
 */
#if !defined( OS_64BIT ) && !defined( OS_32BIT )
    #if defined( __amd64__ ) || defined( __x86_64__ ) || defined( __aarch64__ )
        #define OS_64BIT
    #elif defined( __i386__ )
        #define OS_32BIT
    #else
        #error "Unknown architecture"
    #endif
#endif

#include <hwtypes.h>


#endif /* _OSTYPES_H_ */
